# ステートパターン
class State:  # 状態の基本形クラス
    def say(self, text):  # 抽象メソッド
        pass


class GirlState(State):  # 少女役の状態クラス
    def say(self, text):
        print(f"「わぁ、{text}だね！」")


class WitchState(State):  # 魔女役の状態クラス
    def say(self, text):
        print(f"「ふふふ。、{text}じゃないか。」")


class GrandmotherState(State):  # 老婆役の状態クラス
    def say(self, text):
        print(f"「ほんに、{text}じゃのぉ。」")


class VoiceActress:  # 声優クラス
    def __init__(self):
        # プロパティ
        self._state = State()  # 演じる役の初期状態

    def roleplaying(self, chara):
        role = ["少女", "魔女", "老婆"]
        print(f"State（役の状態）の変更：あなたの役は、{chara}です。")
        if chara == "少女":
            self._state = GirlState()  # 役を切り替える
        elif chara == "魔女":
            self._state = WitchState()  # 役を切り替える
        elif chara == "老婆":
            self._state = GrandmotherState()  # 役を切り替える
        else:
            self._state = State()
            print(f"{role[0]}、{role[1]}、{role[2]}のいずれかの役を入力して下さい。")

    def say(self, text):
        self._state.say(text)  # その役で振る舞う


mirai = VoiceActress()  # 声優インスタンスを作成
role = ["少女", "魔女", "老婆"]
while True:
    chara = input(
        f"声優が演じる役を[{role[0]}、{role[1]}、{role[2]}]の内から１つ入力して下さい。終わりたい場合には、「終わり」と入力して下さい。\n"
    )
    if chara == "終わり":
        break
    mirai.roleplaying(chara)
    mirai.say("今日はいい天気")
