# 弾（Bullet）クラスのプログラム
import pygame as pg


class Bullet:  # 弾クラス
    def __init__(self, rect):
        x = rect.x + 17
        y = rect.y - 10
        # プロパティ
        self._image = pg.image.load("images/bullet.png")
        self._rect = self._image.get_rect()  # 弾のRectオブジェクト
        self._rect.topleft = (x, y)
        self._vy = -8  # 移動量
        self._is_alive = True  # 弾を消すかどうかのフラグ

    @property  # _rectプロパティのゲッターメソッド
    def rect(self):
        return self._rect

    @rect.setter  # _rectプロパティのセッターメソッド
    def rect(self, value):
        self._rect = value

    # メソッド
    def update(self):  # 更新処理
        # 弾は、生成されると上に移動し、画面の上に出ると消える
        self._rect.y += self._vy
        if self._rect.y < -100:
            self._is_alive = False

    def draw(self, screen):  # 描画処理
        screen.blit(self._image, self._rect)
